const debug = require('debug')('eg-plugin-auth-gateway-jwt');
const authorizationService = require('./../service/authorization-service');

module.exports = {
    name: 'authorization-gateway-jwt', policy: (actionParams) => {

        debug('eg-plugin-auth-gateway-jwt LOADED...');

        return (req, res, next) => {

            let token = req.headers.authorization;

            debug('token: %s', token);

            authorizationService.authorize(token).then((response) => {

                debug('Authorization response: \n %j', response);

                let data = JSON.parse(response.body);

                req.headers.idSSO = data.id;

                console.log(data);

                return next();

            }).catch((response) => {

                let error = JSON.parse(response.error);

                if (response.statusCode) {

                    return res.status(response.statusCode).send(error);

                } else {

                    return res.status(500).send('Provedor de autênticação indisponível.');

                }

            });
        };
    }
};